local constants = require("constants")
local util = require("utils")
local rpc = require("rpc")

return function(commands)
	function commands.drawTexture(clientID, args)
		broadcast(clientID, util.unit("drawTexture", args))
	end
	function commands.deleteTexture(clientID, args)
		broadcast(clientID, util.unit("deleteTexture", args))
	end
	function commands.clearCanvas(clientID)
		broadcast(clientID, "clearCanvas")
	end
	function commands.fillCanvas(clientID, args)
		broadcast(clientID, util.unit("fillCanvas", args))
	end
end
